/*
 *  C++ core and functions for BASIN.
 *  Copyright (C) 2006  BASIN team
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
class function{
 public:
  function();
  function(int type, int order);
  void set_order(int order);
  void set_type(int type);
  void set_coeffs(vector<double> coeffs);
  double eval(double);
  vector<double> eval(vector<double>);
  Attribute eval(Attribute& attr);
 private:
  // We need to allow for the possibility 
  int type; // 0 for taylor series
  int order; 
  vector<double> ai;
};


// Create a histogram of the elments of an attribute.  The second 
// argument is the minimum bin value.  The third is the width of the
// bins, and the fourth is number of bins
vector<int> histogram(Attribute&,double,double,int);

// Bin data
template <typename T> vector<double> bin_data_template(Attribute& x, Attribute& y, 
						       vector<double> xbin, T dum);
vector<double> bin_data(Attribute& x, Attribute& y, vector<double> xbin);

//! Compute the mean of an Attribute


double mean(Attribute& var);
// Compute the mean of an attribute using a mask.  The mask (second argument) should 
//! be set to 1 for elements to be included and zero otherwise.
double mean(Attribute& var,Attribute& mask);
//! Compute the standard deviation of an Attribute
double stdev(Attribute& var);
/*! Compute the standard deviation of an Attribute using a mask.  The
mask (second argument) should be set to 1 for elements to be
included and zero otherwise.*/
//! Include this
double stdev(Attribute& var,Attribute& mask);
//
function& poly_fit(Attribute& x, Attribute& y, Attribute &w, int order);
function& poly_fit(Attribute& x, Attribute& y, int order);
function& poly_fit(vector<double>& x, vector<double>& y, vector<double>& w, int order);
function& poly_fit(vector<double>& x, vector<double>& y, int order);

